Add scripts to release from travis-ci

This commit is contained in:
Manuel de Brito Fontes 2017-10-24 00:30:20 -03:00
parent a3ef11b5d0
commit d5a0d34e37
10 changed files with 335 additions and 53 deletions

78
.travis/common.sh Executable file
View file

@ -0,0 +1,78 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
if ! [ -z $DEBUG ]; then
set -x
fi
set -o errexit
set -o nounset
set -o pipefail
# Check if jq binary is installed
if ! [ -x "$(command -v jq)" ]; then
echo "Installing jq..."
sudo apt-get install -y jq
fi
if ! [ "$TRAVIS_REPO_SLUG" == "kubernetes/ingress-nginx" ];
then
echo "Only builds from kubernetes/ingress-nginx repository is allowed.";
exit 0;
fi
# variables QUAY_USERNAME and QUAY_PASSWORD are required to push docker images
if [ "$QUAY_USERNAME" == "" ];
then
echo "Environment variable QUAY_USERNAME is missing.";
exit 0;
fi
if [ "$QUAY_PASSWORD" == "" ];
then
echo "Environment variable QUAY_PASSWORD is missing.";
exit 0;
fi
SKIP_MESSAGE="Publication of docker image to quay.io registry skipped."
if ! [ "$TRAVIS_EVENT_TYPE" == "api" ];
then
echo "Only builds triggered from travis-ci API is allowed. $SKIP_MESSAGE";
exit 0;
fi
if ! [ "$TRAVIS_PULL_REQUEST" == "false" ];
then
echo "This is a pull request. $SKIP_MESSAGE";
exit 0;
fi
if ! [ "$TRAVIS_PULL_REQUEST_BRANCH" == "master" ];
then
echo "Only images build from master branch are allowed. $SKIP_MESSAGE";
exit 0;
fi
function docker_tag_exists() {
TAG=${2//\"/}
IMAGES=$(curl -s -H "Authorization: Bearer ${QUAY_PASSWORD}" https://quay.io/api/v1/repository/$1/image/ | jq '.images | sort_by(.sort_index) | .[] .tags | select(.[] !=null) | .[0]' | sed s/\"//g)
if echo "$IMAGES" | grep -q "$TAG" ; then
return 0
fi
return 1
}

29
.travis/ingress-controller.sh Executable file
View file

@ -0,0 +1,29 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
source $DIR/common.sh
IMAGE=$(make -s -C $DIR/../ image-info)
if docker_tag_exists "aledbf/nginx-ingress-controller" $(echo $IMAGE | jq .tag); then
echo "Image already published"
exit 0
fi
echo "building aledbf/nginx-ingress-controller image..."
make -C $DIR/../ release

29
.travis/nginx-slim.sh Executable file
View file

@ -0,0 +1,29 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
source $DIR/common.sh
IMAGE=$(make -s -C $DIR/../images/nginx-slim image-info)
if docker_tag_exists "aledbf/nginx-slim" $(echo $IMAGE | jq .tag); then
echo "Image already published"
exit 0
fi
echo "building nginx-slim image..."
make -C $DIR/../images/nginx-slim release

38
.travis/publish.sh Executable file
View file

@ -0,0 +1,38 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
source $DIR/common.sh
echo "Login to quay.io..."
echo $QUAY_PASSWORD | docker login --username=$QUAY_USERNAME --password-stdin quay.io >/dev/null 2>&1
case "$COMPONENT" in
"ingress-controller")
$DIR/ingress-controller.sh
;;
"ubuntu-slim")
$DIR/ubuntu-slim.sh
;;
"nginx-slim")
$DIR/nginx-slim.sh
;;
*)
echo "Invalid option in environment variable COMPONENT"
exit 1
;;
esac

63
.travis/release-from-travis.sh Executable file
View file

@ -0,0 +1,63 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
if ! [ -z $DEBUG ]; then
set -x
fi
set -o errexit
set -o pipefail
if [ "$TRAVIS_CI_TOKEN" == "" ];
then
echo "Environment variable TRAVIS_CI_TOKEN is missing.";
exit 1;
fi
function publish() {
body=$(cat <<'EOF'
{
"request": {
"branch": "master",
"config": {
"env": {
"COMPONENT": "$2"
}
}
}
}
EOF
)
echo curl -s -X POST \
-H "Content-Type: application/json" \
-H "Accept: application/json" \
-H "Travis-API-Version: 3" \
-H "Authorization: token $1" \
--data "'$body'" \
https://api.travis-ci.org/repo/kubernetes%2Fingress-nginx/requests
}
case "$1" in
ingress-controller|ubuntu-slim|nginx-slim)
publish $TRAVIS_CI_TOKEN $1
;;
*)
echo "Invalid publish option"
exit 1
;;
esac

29
.travis/ubuntu-slim.sh Executable file
View file

@ -0,0 +1,29 @@
#!/usr/bin/env bash
# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
source $DIR/common.sh
IMAGE=$(make -s -C $DIR/../images/ubuntu-slim image-info)
if docker_tag_exists "aledbf/ubuntu-slim" $(echo $IMAGE | jq .tag); then
echo "Image already published"
exit 0
fi
echo "building ubuntu-slim image..."
make -C $DIR/../images/ubuntu-slim release